#include <QApplication>

#include "PreprocessorThread.h"
#include "Camera.h"
#include "KdTree.h"
#include "SceneGraph.h"
#include "Preprocessor.h"


using namespace GtpVisibilityPreprocessor {


PreprocessorThread::PreprocessorThread(Preprocessor *p,
									   QObject *parent):QThread(parent)
{
  mPreprocessor = p;
  if (p->mQuitOnFinish)
	connect(this, SIGNAL(finished()), qApp, SLOT(closeAllWindows(void)));
}

void
PreprocessorThread::Main()
{
  
  if (mPreprocessor->mComputeVisibility) {
    mPreprocessor->ComputeVisibility();
	//	mPreprocessor->ExportPreprocessedData("scene.vis");
  }
  
  Camera camera;

  if (0) {
    // camera.LookAtBox(mPreprocessor->mKdTree->GetBox());
	//	camera.LookInBox(mPreprocessor->mKdTree->GetBox());
	camera.SetPosition(Vector3(3473, 6.778, -1699));
	camera.SetDirection(Vector3(-0.2432, 0, 0.97));
    camera.SnapImage("camera.jpg", mPreprocessor->mKdTree, mPreprocessor->mSceneGraph);
  }
  if (0) {
    camera.LookInBox(mPreprocessor->mKdTree->GetBox());
    camera.SetPosition(camera.mPosition + Vector3(-250,0,-550));
    camera.SnapImage("camera2.jpg", mPreprocessor->mKdTree, mPreprocessor->mSceneGraph);
  }

  if (0) {
    camera.SetPosition( mPreprocessor->mKdTree->GetBox().Center() - Vector3(0,-100,0) );
	camera.SetDirection(Vector3(1, 0, 0));
	camera.SnapImage("camera3.jpg", mPreprocessor->mKdTree, mPreprocessor->mSceneGraph);
  }


  cerr << "Preprocessor main finished...\n";
  
}

PreprocessorThread::~PreprocessorThread()
{
  cerr<<"Preprocessor thread destructor...\n";
}

}