#ifndef _Renderer_h__
#define _Renderer_h__

#include "common.h"

namespace GtpVisibilityPreprocessor {

class ViewCellsManager;
class SceneGraph;
/** Abstract class used to render the scene.
*/
class Renderer
{

public:

	Renderer();
	Renderer(SceneGraph *sceneGraph, ViewCellsManager *vcm);
	
	~Renderer();

	/** Renders the scene using the current view cell partition.
	*/
	virtual bool RenderScene() = 0;

	void SetViewCellsManager(ViewCellsManager *vcm);

protected:
	ViewCellsManager *mViewCellsManager;
	SceneGraph *mSceneGraph;
};

}

#endif // Renderer
